﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DansApp.Model
{
    //Tots els atributs coinicideixen amb el nom dels camps de la base de dades
    [SQLite.Net.Attributes.Table("Avis")]
    public class Avis
    {
        [SQLite.Net.Attributes.ColumnAttribute("id"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.PrimaryKeyAttribute, SQLite.Net.Attributes.AutoIncrement, SQLite.Net.Attributes.UniqueAttribute]
        public int Id { get; set; }
        [SQLite.Net.Attributes.ColumnAttribute("nom"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.UniqueAttribute]
        public string Nom
        {
            get { return this.nomValue; }

            set
            {
                if (value != this.nomValue)
                {
                    this.nomValue = value;
                    NotifyPropertyChanged("Nom");
                }
            }
        }

        /* Variables privades */
        private int idValue;
        private string nomValue = String.Empty;

        public event PropertyChangedEventHandler PropertyChanged;
        //Notifica que el valor ha canviat.
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        public Avis()
        {
            //Constructor de classe vuit. 
        }
        //Construtor amb paràmetres.
        public Avis(string nom)
        {
            Nom = nom;
        }
    }
}
