﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SQLiteNetExtensions.Attributes;

namespace DansApp.Model
{
    //Tots els atributs coinicideixen amb el nom dels camps de la base de dades
    [SQLite.Net.Attributes.Table("FormaPagament")]
    public class FormaPagament
    {
        [SQLite.Net.Attributes.ColumnAttribute("id"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.PrimaryKeyAttribute, SQLite.Net.Attributes.AutoIncrement, SQLite.Net.Attributes.UniqueAttribute]
        public int Id { get; set; }
        [SQLite.Net.Attributes.ColumnAttribute("num_mesos"), SQLite.Net.Attributes.NotNullAttribute]
        public long? NumMesos
        {
            get { return this.numMesosValue; }

            set
            {
                if (value != this.numMesosValue)
                {
                    this.numMesosValue = value;
                    NotifyPropertyChanged("num_mesos");
                }
            }
        }
        [SQLite.Net.Attributes.ColumnAttribute("descripcio"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.UniqueAttribute]
        public string Descripcio
        {
            get { return this.descripcioValue; }

            set
            {
                if (value != this.descripcioValue)
                {
                    this.descripcioValue = value;
                    NotifyPropertyChanged("Descripcio");
                }
            }
        }

        [OneToMany(CascadeOperations = CascadeOperation.All)]      // Validació de relació un a n
        public List<Activitat> Activitats
        {
            get { return this.activitatsValue; }

            set
            {
                if (value != this.activitatsValue)
                {
                    this.activitatsValue = value;
                    NotifyPropertyChanged("Activitats");
                }
            }
        }

        /* Variables privades */
        private int idValue;
        private long? numMesosValue;
        private string descripcioValue = String.Empty;
        private List<Activitat> activitatsValue;

        public event PropertyChangedEventHandler PropertyChanged;
        //Notifica que el valor ha canviat.
        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        public FormaPagament()
        {
            //Constructor de classe vuit. 
        }
        //Construtor amb paràmetres.
        public FormaPagament(int numMesos, string descripcio)
        {
            NumMesos = numMesos;
            Descripcio = descripcio;
        }
    }
}
