﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Navigation;

namespace DansApp.Model
{
    //Classe que sobreescriu la classe de NavigationExtensions, ja que per defecte no es poden pasar objectes complexes per "Querystring"
    public static class NavigationExtensions
    {
        //Guarda els parámetres que s'han de passar
        private static object _navigationData = null;
        private static object _navigationData2 = null;


        /// <summary> 
        /// Posa les dadaes en l'objecte. 
        /// </summary> 
        /// <param name="service">NavigationService</param> 
        /// <param name="page">Target page.</param> 
        /// <param name="data">Parameter data.</param> 
        public static void Navigate(this NavigationService service, string page, object data)
        {
            _navigationData = data;
            try
            {
                service.Navigate(new Uri(page, UriKind.Relative));
            }
            catch (Exception)
            {
                throw;
            }
        }

        public static void Navigate(this NavigationService service, string page, object data, object data2)
        {
            _navigationData = data;
            _navigationData2 = data2;
            try
            {
                service.Navigate(new Uri(page, UriKind.Relative));
            }
            catch (Exception)
            {
                throw;
            }
        }


        /// <summary> 
        /// Retorna les dades de l'objecte. 
        /// </summary> 
        /// <param name="service">NavigationService</param> 
        /// <returns></returns> 
        public static object GetLastNavigationData(this NavigationService service)
        {
            object data = _navigationData;
            // Reset 
            _navigationData = null;
            return data;
        }

        public static object GetLastTwoNavigationData(this NavigationService service)
        {
            object data2 = _navigationData2;
            // Reset 
            _navigationData2 = null;
            return data2;
        }
    }
}
