﻿using System;
using System.ComponentModel;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SQLiteNetExtensions.Attributes;

namespace DansApp.Model
{
    //Tots els atributs coinicideixen amb el nom dels camps de la base de dades
    [SQLite.Net.Attributes.Table("Nivell")]
    public class Nivell : INotifyPropertyChanged
    {
        [SQLite.Net.Attributes.ColumnAttribute("id"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.PrimaryKeyAttribute, SQLite.Net.Attributes.AutoIncrement, SQLite.Net.Attributes.UniqueAttribute]
        public int Id { get; set; }
        [SQLite.Net.Attributes.ColumnAttribute("nom"), SQLite.Net.Attributes.NotNullAttribute, SQLite.Net.Attributes.UniqueAttribute]
        public string Nom
        {
            get { return this.nomValue; }

            set
            {
                if (value != this.nomValue)
                {
                    this.nomValue = value;
                    NotifyPropertyChanged("Nom");
                }
            }
        }

        [SQLiteNetExtensions.Attributes.OneToMany(CascadeOperations = CascadeOperation.All)]      // Validació de relación un a n
        public List<Activitat> Activitats
        {
            get { return this.activitatsValue; }

            set
            {
                if (value != this.activitatsValue)
                {
                    this.activitatsValue = value;
                    NotifyPropertyChanged("Activitats");
                }
            }
        }

        /* Variables privades */
        private int idValue;
        private string nomValue = String.Empty;
        private List<Activitat> activitatsValue;

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

        public Nivell()
        {
            //Constructor de classe vuit. 
        }
        //Construtor amb paràmetres.
        public Nivell(string nom, List<Activitat> activitats)
        {
            Nom = nom;
            Activitats = activitats;
        }
    }
}
