﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;
using DansApp.Model;
using System.Windows.Media;
using System.Collections.ObjectModel;

namespace DansApp.Views.Activitat
{
    public partial class AddActivitat : PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Nivell> DB_NivellsList = new ObservableCollection<DansApp.Model.Nivell>();
        ObservableCollection<DansApp.Model.FormaPagament> DB_PagamentsList = new ObservableCollection<DansApp.Model.FormaPagament>();
        Model.Activitat newactivitat = new Model.Activitat();
        List<string> listMesos = new List<string>();
        List<string> listDies = new List<string>();

        public AddActivitat()
        {
            InitializeComponent();
            lbNivell.SelectionMode = SelectionMode.Single;
            lbFormaPagament.SelectionMode = SelectionMode.Single;

            this.Loaded += ReadActivitatsList_Loaded;
        }

        private void ReadActivitatsList_Loaded(object sender, RoutedEventArgs e)
        {
            if (listMesos.Count == 0)
            {
                listMesos.Add("Gener");
                listMesos.Add("Febrer");
                listMesos.Add("Març");
                listMesos.Add("Abril");
                listMesos.Add("Maig");
                listMesos.Add("Juny");
                listMesos.Add("Juliol");
                listMesos.Add("Agost");
                listMesos.Add("Septembre");
                listMesos.Add("Octubre");
                listMesos.Add("Novembre");
                listMesos.Add("Desembre");
            }
            llMes.ItemsSource = listMesos;

            if (listDies.Count == 0)
            {
                listDies.Add("Dilluns");
                listDies.Add("Dimarts");
                listDies.Add("Dimecres");
                listDies.Add("Dijous");
                listDies.Add("Divendres");
                listDies.Add("Dissabte");
                listDies.Add("Diumenge");
            }
            llDia.ItemsSource = listDies;

            ReadAllNivellsList dbnivells = new ReadAllNivellsList();
            ReadAllFormaPagamentsList dbpagaments = new ReadAllFormaPagamentsList();
            if (DB_NivellsList.Count == 0)
            {
                DB_NivellsList = dbnivells.GetAllNivells();//Get all DB contacts
                lbNivell.ItemsSource = DB_NivellsList.OrderBy(i => i.Id).ToList();//Latest contact ID can Display first
            }

            if (DB_PagamentsList.Count == 0)
            { 
                DB_PagamentsList = dbpagaments.GetAllFormaPagaments();//Get all DB contacts
                lbFormaPagament.ItemsSource = DB_PagamentsList.OrderBy(i => i.Id).ToList();//Latest contact ID can Display first
            }

            if (newactivitat.Aulas == null)
            {
                newactivitat.Aulas = new List<Model.Aula>();
            }
            if (newactivitat.Professors == null)
            {
                newactivitat.Professors = new List<Model.Professor>();
            }
            if (newactivitat.Alumnes == null)
            {
                newactivitat.Alumnes = new List<Model.Alumne>();
            }
            if (NavigationContext.QueryString.ContainsKey("activitat"))
            {
                string parameter = NavigationContext.QueryString["activitat"];

                switch (parameter)
                {
                    case "1":
                        var myParameter = NavigationService.GetLastNavigationData();
                        if (myParameter != null)
                        {
                            newactivitat = (Model.Activitat)myParameter;
                            if (newactivitat != null)
                            {
                                txtNom.Text = newactivitat.Nom;
                                //lbNivell.SelectedItem = newactivitat.NivellId;
                                lbNivell.SelectedIndex = newactivitat.NivellId - 1;
                                txtPreu.Text = newactivitat.Preu.ToString();
                                //lbFormaPagament.SelectedItem = newactivitat.FormaPagamentId;
                                lbFormaPagament.SelectedIndex = newactivitat.FormaPagamentId - 1;
                                string[] m = newactivitat.Mes.Split(';');
                                foreach(var mes in m)
                                {
                                    if (!string.IsNullOrEmpty(mes))
                                    {
                                        llMes.SelectedItems.Add(mes);
                                    }
                                }

                                string[] d = newactivitat.Dia.Split(';');
                                foreach (var dia in d)
                                {
                                    if (!string.IsNullOrEmpty(dia))
                                    {
                                        llDia.SelectedItems.Add(dia);
                                    }
                                }

                                if (!string.IsNullOrEmpty(newactivitat.Hora))
                                {
                                    txtHora.Value = DateTime.Parse(newactivitat.Hora);
                                }

                                if (newactivitat.Aulas != null)
                                {
                                    lbAules.ItemsSource = newactivitat.Aulas.OrderBy(i => i.Nom).ToList();
                                }

                                if (newactivitat.Professors != null)
                                {
                                    lbProfessors.ItemsSource = newactivitat.Professors.OrderBy(i => i.Nom).ToList();
                                }

                                if (newactivitat.Alumnes != null)
                                {
                                    lbAlumnes.ItemsSource = newactivitat.Alumnes.OrderBy(i => i.Nom).ToList();
                                }
                            }
                        }
                        break;
                    default:
                        break;
                }
            }
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void btnAddActivitat_Click(object sender, RoutedEventArgs e)
        {
            DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
            decimal preu;
            Model.Utils utils = new Utils();
            
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            string mesos = utils.GetSelectedItemsAndTransformToStringSeparateBySemicolon(llMes);

            string dies = utils.GetSelectedItemsAndTransformToStringSeparateBySemicolon(llDia);

            if (string.IsNullOrEmpty(txtNom.Text))
            {
                MessageBox.Show("El nom és obligatori!");
            }
            else if (lbNivell.SelectedIndex == -1)
            {
                MessageBox.Show("El nivell és obligatori!");
            }
            else if (string.IsNullOrEmpty(txtPreu.Text))
            {
                MessageBox.Show("El preu és obligatori!");
            }
            else if (!(decimal.TryParse(txtPreu.Text, out preu)))
            {
                MessageBox.Show("El preu ha de ser un número!");
            }
            else if (lbFormaPagament.SelectedIndex == -1)
            {
                MessageBox.Show("La forma de pagament és obligatoria!");
            }
            else if (string.IsNullOrEmpty(mesos))
            {
                MessageBox.Show("El mes és obligatori!");
            }
            else if (string.IsNullOrEmpty(dies))
            {
                MessageBox.Show("El dia és obligatori!");
            }
            else if (string.IsNullOrEmpty(txtHora.ValueString))
            {
                MessageBox.Show("L'hora és obligatoria!");
            }
            else if (liFormaPagament.NumMesos > llMes.SelectedItems.Count)
            {
                MessageBox.Show("Els números de mesos seleccionats han de ser igual o superiors a la forma de pagament!");
            }
            else
            {
                Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
                newactivitat.Nom = txtNom.Text;
                newactivitat.NivellId = liNivell.Id;
                newactivitat.Nivell = liNivell;
                newactivitat.Preu = preu;
                newactivitat.FormaPagamentId = liFormaPagament.Id;
                newactivitat.FormaPagament = liFormaPagament;
                newactivitat.Mes = mesos;
                newactivitat.Dia = dies;
                newactivitat.Hora = txtHora.ValueString;
                newactivitat.PreuTotal = preu * newactivitat.FormaPagament.NumMesos;

                Db_Helper.Insert(newactivitat);
                NavigationService.Navigate(new Uri("/Views/Activitat/ReadActivitatList.xaml", UriKind.Relative));//after add contact redirect to contact listbox page
            }
        }

        private void btnSelAules_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            newactivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                newactivitat.NivellId = liNivell.Id;
                newactivitat.Nivell = liNivell;
            }
            newactivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                newactivitat.FormaPagamentId = liFormaPagament.Id;
                newactivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            newactivitat.Mes = mesos;

            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            newactivitat.Dia = dies;
            newactivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectAulaActivitat.xaml?activitat=1", UriKind.Relative).ToString(), newactivitat);
        }

        private void btnSelProfessors_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            newactivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                newactivitat.NivellId = liNivell.Id;
                newactivitat.Nivell = liNivell;
            }
            newactivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                newactivitat.FormaPagamentId = liFormaPagament.Id;
                newactivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            newactivitat.Mes = mesos;
            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            newactivitat.Dia = dies;
            newactivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectProfessorActivitat.xaml?activitat=1", UriKind.Relative).ToString(), newactivitat);
        }

        private void btnSelAlumnes_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            newactivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                newactivitat.NivellId = liNivell.Id;
                newactivitat.Nivell = liNivell;
            }
            newactivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                newactivitat.FormaPagamentId = liFormaPagament.Id;
                newactivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            newactivitat.Mes = mesos;
            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            newactivitat.Dia = dies;
            newactivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectAlumneActivitat.xaml?activitat=1", UriKind.Relative).ToString(), newactivitat);
        }

        private void txtHora_ValueChanged(object sender, DateTimeValueChangedEventArgs e)
        {
            if (txtHora != null && newactivitat != null)
            {
                newactivitat.Hora = txtHora.ValueString;
            }
        }
    }
}