﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;

namespace DansApp.Views
{
    public partial class DetailActivitat : PhoneApplicationPage
    {
        int Selected_ActivitatId = 0;

        DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
        Model.Activitat currentActivitat = new Model.Activitat();
        List<string> listMesos = new List<string>();
        List<string> listDies = new List<string>();

        public DetailActivitat()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            Selected_ActivitatId = int.Parse(NavigationContext.QueryString["SelectedActivitatID"]);
            currentActivitat = Db_Helper.ReadActivitat(Selected_ActivitatId);
            txtNom.Text = currentActivitat.Nom;
            txtNivell.Text = currentActivitat.Nivell.Nom;
            txtPreu.Text = currentActivitat.Preu.ToString();
            txtFormaPagament.Text = currentActivitat.FormaPagament.Descripcio;
            string[] m = currentActivitat.Mes.Split(';');
            foreach (var mes in m)
            {
                if (!string.IsNullOrEmpty(mes))
                {
                    listMesos.Add(mes);
                }
            }
            string[] d = currentActivitat.Dia.Split(';');
            foreach (var dia in d)
            {
                if (!string.IsNullOrEmpty(dia))
                {
                    listDies.Add(dia);
                }
            }

            if(listMesos.Count > 0)
            {
                lbMes.ItemsSource = listMesos;
            }

            if (listDies.Count > 0)
            {
                lbDia.ItemsSource = listDies;
            }

            txtHora.Text = currentActivitat.Hora;
            lbAules.ItemsSource = currentActivitat.Aulas.OrderBy(i => i.Nom).ToList();
            lbProfessors.ItemsSource = currentActivitat.Professors.OrderBy(i => i.Nom).ToList();

            var alumnes = currentActivitat.Alumnes;
            foreach (var alumne in alumnes)
            {
                alumne.HaPagat = Db_Helper.ReadHaPagat(alumne.Id, currentActivitat.Id);
            }
            lbAlumnes.ItemsSource = currentActivitat.Alumnes.OrderBy(i => i.Nom).ToList();
        }

        private void btnUpdateDeleteActivitat_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Activitat/UpdateDeleteActivitat.xaml?SelectedActivitatID=" + Selected_ActivitatId, UriKind.Relative));
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void txtNom_Click(object sender, RoutedEventArgs e)
        {
            var listitem = (sender as ToggleSwitch).DataContext as Model.Alumne;
            Db_Helper.UpdateHaPagat(listitem.Id, currentActivitat.Id);
        }
    }
}