﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using System.Windows.Navigation;
using DansApp.Model;

namespace DansApp.Views.Activitat
{
    public partial class ReadActivitatList : PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Activitat> DB_ActivitatsList = new ObservableCollection<DansApp.Model.Activitat>();
        ReadAllActivitatsList dbactivitats = new ReadAllActivitatsList();

        public ReadActivitatList()
        {
            InitializeComponent();

            this.Loaded += ReadActivitatList_Loaded;
        }

        private void ReadActivitatList_Loaded(object sender, RoutedEventArgs e)
        {
            DB_ActivitatsList = dbactivitats.GetAllActivitats();
            listBoxobj.ItemsSource = DB_ActivitatsList.OrderBy(i => i.Nom).ToList();
        }

        private void btnAddActivitat_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Activitat/AddActivitat.xaml", UriKind.Relative));
        }

        private void listBoxobj_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (listBoxobj.SelectedIndex != -1)
            {
                Model.Activitat listitem = listBoxobj.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void btnCalendar_Click(object sender, RoutedEventArgs e)
        {
            Model.Activitat listitem = (sender as Button).DataContext as Model.Activitat;
            NavigationService.Navigate(new Uri("/Views/Calendari/ReadCalendari.xaml?activitats=1", UriKind.Relative).ToString(), new List<Model.Activitat>() { listitem });
        }

        private void FilterString_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.listBoxobj.ItemsSource = DB_ActivitatsList.Where(w => w.Nom.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || w.Nivell.Nom.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || w.Hora.ToUpper().Contains(SearchTextBox.Text.ToUpper()));

        }
    }
}