﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Activitat
{
    public partial class SelectAlumneActivitat: PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Alumne> DB_AlumnesList = new ObservableCollection<DansApp.Model.Alumne>();
        Model.Activitat act = new Model.Activitat();

        public SelectAlumneActivitat()
        {
            InitializeComponent();

            this.Loaded += ReadAlumneList_Loaded;
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void ReadAlumneList_Loaded(object sender, RoutedEventArgs e)
        {
            ReadAllAlumnesList dbalumnes = new ReadAllAlumnesList();
            DB_AlumnesList = dbalumnes.GetAllAlumnes();//Get all DB contacts

            if (NavigationContext.QueryString.ContainsKey("activitat"))
            {
                string parameter = NavigationContext.QueryString["activitat"];

                switch (parameter)
                {
                    case "1":
                        var myParameter = NavigationService.GetLastNavigationData();
                        if (myParameter != null)
                        {
                            act = (Model.Activitat)myParameter;
                            
                            foreach (var alumne in act.Alumnes)
                            {
                                Model.Alumne alu = DB_AlumnesList.FirstOrDefault(x => x.Id == alumne.Id);
                                if (alu != null)
                                {
                                    alu.CheckboxState = true;
                                }
                            }
                            
                        }
                        break;
                    default:
                        break;
                }
            }

                lbAlumnes.ItemsSource = DB_AlumnesList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }

        private void btnSeleccionar_Click(object sender, RoutedEventArgs e)
        {
            if (act.Id != 0)
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/UpdateDeleteActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
            else
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/AddActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
        }
        
        private void lbAlumnes_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            Model.Alumne listitem = lbAlumnes.SelectedItem as Model.Alumne;
            
            if (listitem != null)
            {
                if (!listitem.CheckboxState)
                {
                    listitem.CheckboxState = true;
                    Model.Alumne alu = act.Alumnes.FirstOrDefault(x => x.Id == listitem.Id);

                    if (alu == null)
                    {
                        act.Alumnes.Add(listitem);
                    }
                }
                else
                {
                    listitem.CheckboxState = false;
                    Model.Alumne alu = act.Alumnes.FirstOrDefault(x => x.Id == listitem.Id);

                    if(alu != null)
                    {
                        act.Alumnes.Remove(alu);
                    }
                }
            }
        }
    }
}