﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Activitat
{
    public partial class SelectAulaActivitat: PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Aula> DB_AulesList = new ObservableCollection<DansApp.Model.Aula>();
        Model.Activitat act = new Model.Activitat();

        public SelectAulaActivitat()
        {
            InitializeComponent();

            this.Loaded += ReadAulaList_Loaded;
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void ReadAulaList_Loaded(object sender, RoutedEventArgs e)
        {
            ReadAllAulasList dbaules = new ReadAllAulasList();
            DB_AulesList = dbaules.GetAllAulas();//Get all DB contacts

            if (NavigationContext.QueryString.ContainsKey("activitat"))
            {
                string parameter = NavigationContext.QueryString["activitat"];

                switch (parameter)
                {
                    case "1":
                        var myParameter = NavigationService.GetLastNavigationData();
                        if (myParameter != null)
                        {
                            act = (Model.Activitat)myParameter;
                            
                            foreach (var aula in act.Aulas)
                            {
                                Model.Aula au = DB_AulesList.FirstOrDefault(x => x.Id == aula.Id);
                                if (au != null)
                                {
                                    au.CheckboxState = true;
                                }
                            }
                            
                        }
                        break;
                    default:
                        break;
                }
            }

                lbAules.ItemsSource = DB_AulesList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }

        private void btnSeleccionar_Click(object sender, RoutedEventArgs e)
        {
            if (act.Id != 0)
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/UpdateDeleteActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
            else
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/AddActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
        }
        
        private void lbAules_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            Model.Aula listitem = lbAules.SelectedItem as Model.Aula;
            
            if (listitem != null)
            {
                if (!listitem.CheckboxState)
                {
                    listitem.CheckboxState = true;
                    Model.Aula au = act.Aulas.FirstOrDefault(x => x.Id == listitem.Id);

                    if (au == null)
                    {
                        act.Aulas.Add(listitem);
                    }
                }
                else
                {
                    listitem.CheckboxState = false;
                    Model.Aula au = act.Aulas.FirstOrDefault(x => x.Id == listitem.Id);

                    if(au != null)
                    {
                        act.Aulas.Remove(au);
                    }
                }
            }
        }
    }
}