﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Activitat
{
    public partial class SelectProfessorActivitat: PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Professor> DB_ProfessorsList = new ObservableCollection<DansApp.Model.Professor>();
        Model.Activitat act = new Model.Activitat();

        public SelectProfessorActivitat()
        {
            InitializeComponent();

            this.Loaded += ReadProfessorList_Loaded;
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void ReadProfessorList_Loaded(object sender, RoutedEventArgs e)
        {
            ReadAllProfessorsList dbprofessors = new ReadAllProfessorsList();
            DB_ProfessorsList = dbprofessors.GetAllProfessors();//Get all DB contacts

            if (NavigationContext.QueryString.ContainsKey("activitat"))
            {
                string parameter = NavigationContext.QueryString["activitat"];

                switch (parameter)
                {
                    case "1":
                        var myParameter = NavigationService.GetLastNavigationData();
                        if (myParameter != null)
                        {
                            act = (Model.Activitat)myParameter;
                            
                            foreach (var professor in act.Professors)
                            {
                                Model.Professor prof = DB_ProfessorsList.FirstOrDefault(x => x.Id == professor.Id);
                                if (prof != null)
                                {
                                    prof.CheckboxState = true;
                                }
                            }
                            
                        }
                        break;
                    default:
                        break;
                }
            }

                lbProfessors.ItemsSource = DB_ProfessorsList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }

        private void btnSeleccionar_Click(object sender, RoutedEventArgs e)
        {
            if (act.Id != 0)
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/UpdateDeleteActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
            else
            {
                NavigationService.Navigate(new Uri("/Views/Activitat/AddActivitat.xaml?activitat=1", UriKind.Relative).ToString(), act);
            }
        }
        
        private void lbProfessors_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            Model.Professor listitem = lbProfessors.SelectedItem as Model.Professor;
            
            if (listitem != null)
            {
                if (!listitem.CheckboxState)
                {
                    listitem.CheckboxState = true;
                    Model.Professor prof = act.Professors.FirstOrDefault(x => x.Id == listitem.Id);

                    if (prof == null)
                    {
                        act.Professors.Add(listitem);
                    }
                }
                else
                {
                    listitem.CheckboxState = false;
                    Model.Professor prof = act.Professors.FirstOrDefault(x => x.Id == listitem.Id);

                    if(prof != null)
                    {
                        act.Professors.Remove(prof);
                    }
                }
            }
        }
    }
}