﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;
using System.Collections.ObjectModel;
using DansApp.Model;


namespace DansApp.Views.Activitat
{
    public partial class UpdateDeleteActivitat : PhoneApplicationPage
    {
        int Selected_ActivitatId = 0;
        ObservableCollection<DansApp.Model.Nivell> DB_NivellsList = new ObservableCollection<DansApp.Model.Nivell>();
        ObservableCollection<DansApp.Model.FormaPagament> DB_PagamentsList = new ObservableCollection<DansApp.Model.FormaPagament>();
        List<string> listMesos = new List<string>();
        List<string> listDies = new List<string>();

        DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
        Model.Activitat currentActivitat = new Model.Activitat();

        public UpdateDeleteActivitat()
        {
            InitializeComponent();
            this.Loaded += UpdateDeleteActivitat_Loaded;
        }

        private void UpdateDeleteActivitat_Loaded(object sender, RoutedEventArgs e)
        {
            ReadAllNivellsList dbnivells = new ReadAllNivellsList();
            DB_NivellsList = dbnivells.GetAllNivells();//Get all DB contacts
            lbNivell.ItemsSource = DB_NivellsList.OrderBy(i => i.Id).ToList();//Latest contact ID can Display first
            ReadAllFormaPagamentsList dbpagaments = new ReadAllFormaPagamentsList();
            DB_PagamentsList = dbpagaments.GetAllFormaPagaments();//Get all DB contacts
            lbFormaPagament.ItemsSource = DB_PagamentsList.OrderBy(i => i.Id).ToList();//Latest contact ID can Display first

            if (listMesos.Count == 0)
            {
                listMesos.Add("Gener");
                listMesos.Add("Febrer");
                listMesos.Add("Març");
                listMesos.Add("Abril");
                listMesos.Add("Maig");
                listMesos.Add("Juny");
                listMesos.Add("Juliol");
                listMesos.Add("Agost");
                listMesos.Add("Septembre");
                listMesos.Add("Octubre");
                listMesos.Add("Novembre");
                listMesos.Add("Desembre");
            }
            llMes.ItemsSource = listMesos;

            if (listDies.Count == 0)
            {
                listDies.Add("Dilluns");
                listDies.Add("Dimarts");
                listDies.Add("Dimecres");
                listDies.Add("Dijous");
                listDies.Add("Divendres");
                listDies.Add("Dissabte");
                listDies.Add("Diumenge");
            }
            llDia.ItemsSource = listDies;

            if (NavigationContext.QueryString.ContainsKey("SelectedActivitatID"))
            {
                Selected_ActivitatId = int.Parse(NavigationContext.QueryString["SelectedActivitatID"]);
                currentActivitat = Db_Helper.ReadActivitat(Selected_ActivitatId);

                txtNom.Text = currentActivitat.Nom;
                //lbNivell.SelectedItem = currentActivitat.NivellId;
                lbNivell.SelectedIndex = currentActivitat.NivellId - 1;
                txtPreu.Text = currentActivitat.Preu.ToString();
                //lbFormaPagament.SelectedItem = currentActivitat.FormaPagamentId;
                lbFormaPagament.SelectedIndex = currentActivitat.FormaPagamentId - 1;
                string[] m = currentActivitat.Mes.Split(';');
                foreach (var mes in m)
                {
                    if (!string.IsNullOrEmpty(mes))
                    {
                        llMes.SelectedItems.Add(mes);
                    }
                }
                string[] d = currentActivitat.Dia.Split(';');
                foreach (var dia in d)
                {
                    if (!string.IsNullOrEmpty(dia))
                    {
                        llDia.SelectedItems.Add(dia);
                    }
                }

                if (string.IsNullOrEmpty(txtHora.ValueString))
                {
                    txtHora.Value = DateTime.Parse(currentActivitat.Hora);
                }
                else
                {
                    currentActivitat.Hora = txtHora.ValueString;
                }

                lbAules.ItemsSource = currentActivitat.Aulas.OrderBy(i => i.Nom).ToList();
                lbProfessors.ItemsSource = currentActivitat.Professors.OrderBy(i => i.Nom).ToList();
                lbAlumnes.ItemsSource = currentActivitat.Alumnes.OrderBy(i => i.Nom).ToList();
            }
            else
            {
                if (NavigationContext.QueryString.ContainsKey("activitat"))
                {
                    string parameter = NavigationContext.QueryString["activitat"];

                    switch (parameter)
                    {
                        case "1":
                            var myParameter = NavigationService.GetLastNavigationData();
                            if (myParameter != null)
                            {
                                currentActivitat = (Model.Activitat)myParameter;

                                if (currentActivitat != null)
                                {
                                    txtNom.Text = currentActivitat.Nom;
                                    //lbNivell.SelectedItem = currentActivitat.NivellId;
                                    lbNivell.SelectedIndex = currentActivitat.NivellId - 1;
                                    txtPreu.Text = currentActivitat.Preu.ToString();
                                    //lbFormaPagament.SelectedItem = currentActivitat.FormaPagamentId;
                                    lbFormaPagament.SelectedIndex = currentActivitat.FormaPagamentId - 1;
                                    string[] m = currentActivitat.Mes.Split(';');
                                    foreach (var mes in m)
                                    {
                                        if (!string.IsNullOrEmpty(mes))
                                        {
                                            llMes.SelectedItems.Add(mes);
                                        }
                                    }
                                    string[] d = currentActivitat.Dia.Split(';');
                                    foreach (var dia in d)
                                    {
                                        if (!string.IsNullOrEmpty(dia))
                                        {
                                            llDia.SelectedItems.Add(dia);
                                        }
                                    }
                                    if (!string.IsNullOrEmpty(currentActivitat.Hora))
                                    {
                                        txtHora.Value = DateTime.Parse(currentActivitat.Hora);
                                    }

                                    if (currentActivitat.Aulas != null)
                                    {
                                        lbAules.ItemsSource = currentActivitat.Aulas.OrderBy(i => i.Nom).ToList();
                                    }

                                    if (currentActivitat.Professors != null)
                                    {
                                        lbProfessors.ItemsSource = currentActivitat.Professors.OrderBy(i => i.Nom).ToList();
                                    }

                                    if (currentActivitat.Alumnes != null)
                                    {
                                        lbAlumnes.ItemsSource = currentActivitat.Alumnes.OrderBy(i => i.Nom).ToList();
                                    }
                                }
                            }
                            break;
                        default:
                            break;
                    }
                }
            }
        }

        private void btnUpdateActivitat_Click(object sender, RoutedEventArgs e)
        {
            decimal preu;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            if (string.IsNullOrEmpty(txtNom.Text))
            {
                MessageBox.Show("El nom és obligatori!");
            }
            else if (lbNivell.SelectedIndex == -1)
            {
                MessageBox.Show("El nivell és obligatori!");
            }
            else if (string.IsNullOrEmpty(txtPreu.Text))
            {
                MessageBox.Show("El preu és obligatori!");
            }
            else if(!(decimal.TryParse(txtPreu.Text, out preu)))
            {
                MessageBox.Show("El preu ha de ser un número!");
            }
            else if (lbNivell.SelectedIndex == -1)
            {
                MessageBox.Show("La forma de pagament és obligatoria!");
            }
            else if (string.IsNullOrEmpty(mesos))
            {
                MessageBox.Show("El mes és obligatori!");
            }
            else if (string.IsNullOrEmpty(dies))
            {
                MessageBox.Show("El dia és obligatori!");
            }
            else if (string.IsNullOrEmpty(txtHora.ValueString))
            {
                MessageBox.Show("la hora és obligatoria!");
            }
            else if (liFormaPagament.NumMesos > llMes.SelectedItems.Count)
            {
                MessageBox.Show("Els números de mesos seleccionats han de ser igual o superiors a la forma de pagament!");
            }
            else
            {
                currentActivitat.Nom = txtNom.Text;
                Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;

                currentActivitat.NivellId = liNivell.Id;
                currentActivitat.Nivell = liNivell;
                currentActivitat.Preu = preu;

                currentActivitat.FormaPagamentId = liFormaPagament.Id;
                currentActivitat.FormaPagament = liFormaPagament;
                currentActivitat.Mes= mesos;
                currentActivitat.Dia = dies;
                currentActivitat.Hora = txtHora.ValueString;

                currentActivitat.PreuTotal = preu * currentActivitat.FormaPagament.NumMesos;

                Db_Helper.UpdateActivitat(currentActivitat);
                NavigationService.Navigate(new Uri("/Views/Activitat/ReadActivitatList.xaml", UriKind.Relative));
            }
            }

        private void btnDeleteActivitat_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult msg = MessageBox.Show("Estàs segur? Això eliminarà el registre", "Atenció!", MessageBoxButton.OKCancel);
            if (msg == MessageBoxResult.Cancel)
            {

            }
            else
            {
                Db_Helper.DeleteActivitat(Selected_ActivitatId);
                NavigationService.Navigate(new Uri("/Views/Activitat/ReadActivitatList.xaml", UriKind.Relative));
            }
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void btnSelAules_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            currentActivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                currentActivitat.NivellId = liNivell.Id;
                currentActivitat.Nivell = liNivell;
            }
            currentActivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                currentActivitat.FormaPagamentId = liFormaPagament.Id;
                currentActivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            currentActivitat.Mes = mesos;

            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            currentActivitat.Dia = dies;
            currentActivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectAulaActivitat.xaml?activitat=1", UriKind.Relative).ToString(), currentActivitat);
        }

        private void btnSelProfessors_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            currentActivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                currentActivitat.NivellId = liNivell.Id;
                currentActivitat.Nivell = liNivell;
            }
            currentActivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                currentActivitat.FormaPagamentId = liFormaPagament.Id;
                currentActivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            currentActivitat.Mes = mesos;

            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            currentActivitat.Dia = dies;
            currentActivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectProfessorActivitat.xaml?activitat=1", UriKind.Relative).ToString(), currentActivitat);
        }

        private void btnSelAlumnes_Click(object sender, RoutedEventArgs e)
        {
            long tempVal;
            long? preu = Int64.TryParse(txtPreu.Text, out tempVal) ? tempVal : (long?)null;
            Model.Nivell liNivell = lbNivell.SelectedItem as Model.Nivell;
            Model.FormaPagament liFormaPagament = lbFormaPagament.SelectedItem as Model.FormaPagament;

            currentActivitat.Nom = txtNom.Text;
            if (liNivell != null)
            {
                currentActivitat.NivellId = liNivell.Id;
                currentActivitat.Nivell = liNivell;
            }
            currentActivitat.Preu = preu;
            if (liFormaPagament != null)
            {
                currentActivitat.FormaPagamentId = liFormaPagament.Id;
                currentActivitat.FormaPagament = liFormaPagament;
            }
            string mesos = string.Empty;
            for (var i = 0; i < llMes.SelectedItems.Count; i++)
            {
                mesos = mesos + llMes.SelectedItems[i].ToString();
                if (i != llMes.SelectedItems.Count - 1)
                {
                    mesos = mesos + ";";
                }
            }

            currentActivitat.Mes = mesos;

            string dies = string.Empty;
            for (var i = 0; i < llDia.SelectedItems.Count; i++)
            {
                dies = dies + llDia.SelectedItems[i].ToString();
                if (i != llDia.SelectedItems.Count - 1)
                {
                    dies = dies + ";";
                }
            }

            currentActivitat.Dia = dies;
            currentActivitat.Hora = txtHora.ValueString;

            NavigationService.Navigate(new Uri("/Views/Activitat/SelectAlumneActivitat.xaml?activitat=1", UriKind.Relative).ToString(), currentActivitat);
        }

        private void txtHora_ValueChanged(object sender, DateTimeValueChangedEventArgs e)
        {
            if (txtHora != null && currentActivitat != null)
            {
                currentActivitat.Hora = txtHora.ValueString;
            }
        }
    }
}