﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;

namespace DansApp.Views.Alumne
{
    public partial class DetailAlumne : PhoneApplicationPage
    {
        int Selected_AlumneId = 0;

        DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
        Model.Alumne currentAlumne = new Model.Alumne();

        public DetailAlumne()
        {
            InitializeComponent();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            Selected_AlumneId = int.Parse(NavigationContext.QueryString["SelectedAlumneID"]);
            currentAlumne = Db_Helper.ReadAlumne(Selected_AlumneId);
            txtNom.Text = currentAlumne.Nom;
            txtCognoms.Text = currentAlumne.Cognoms;
            txtEmail.Text = currentAlumne.Email;
            txtTelefon.Text = currentAlumne.Telefon.ToString();
            foreach(var activitat in currentAlumne.Activitats)
            {
                activitat.HaPagat = Db_Helper.ReadHaPagat(currentAlumne.Id, activitat.Id);
            }

            listBoxobj.ItemsSource = currentAlumne.Activitats.OrderBy(i => i.Nom).ToList();
        }

        private void btnUpdateDeleteAlumne_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Alumne/UpdateDeleteAlumne.xaml?SelectedAlumneID=" + Selected_AlumneId, UriKind.Relative));
        }
        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void txtNom_Click(object sender, RoutedEventArgs e)
        {
            var listitem = (sender as ToggleSwitch).DataContext as Model.Activitat;
            Db_Helper.UpdateHaPagat(currentAlumne.Id, listitem.Id);
        }
    }
}