﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Alumne
{
    public partial class ReadAlumneList : PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Alumne> DB_AlumnesList = new ObservableCollection<DansApp.Model.Alumne>();
        ReadAllAlumnesList dbalumnes = new ReadAllAlumnesList();

        public ReadAlumneList()
        {
            InitializeComponent();

            this.Loaded += ReadAlumneList_Loaded;
        }

        private void ReadAlumneList_Loaded(object sender, RoutedEventArgs e)
        {
            DB_AlumnesList = dbalumnes.GetAllAlumnes();//Get all DB contacts
            foreach (var alumne in DB_AlumnesList)
            {
                if (alumne.Activitats.Count > 0)
                {
                    alumne.HaveActivitats = "Visible";
                }
            }
            listBoxobj.ItemsSource = DB_AlumnesList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }


        private void btnAddAlumne_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Alumne/AddAlumne.xaml", UriKind.Relative));
        }

        private void listBoxobj_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (listBoxobj.SelectedIndex != -1)
            {
                Model.Alumne listitem = listBoxobj.SelectedItem as Model.Alumne;
                NavigationService.Navigate(new Uri("/Views/Alumne/DetailAlumne.xaml?SelectedAlumneID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void btnCalendar_Click(object sender, RoutedEventArgs e)
        {
            Model.Alumne listitem = (sender as Button).DataContext as Model.Alumne;
            NavigationService.Navigate(new Uri("/Views/Calendari/ReadCalendari.xaml?activitats=1", UriKind.Relative).ToString(), listitem.Activitats);
        }

        private void FilterString_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.listBoxobj.ItemsSource = DB_AlumnesList.Where(w => w.Nom.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || w.Cognoms.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || (w.Nom.ToUpper() + " " + w.Cognoms.ToUpper()).Contains(SearchTextBox.Text.ToUpper()));

        }
    }
}