﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;
using DansApp.Model;
using System.Collections.ObjectModel;

namespace DansApp.Views.Aula
{
    public partial class ReadAulaList : PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Aula> DB_AulasList = new ObservableCollection<DansApp.Model.Aula>();
        
        ReadAllAulasList dbaulas = new ReadAllAulasList();

        public ReadAulaList()
        {
            InitializeComponent();
            this.Loaded += ReadAulaList_Loaded;
        }

        private void ReadAulaList_Loaded(object sender, RoutedEventArgs e)
        {
            DB_AulasList = dbaulas.GetAllAulas();//Get all DB contacts
            foreach (var aula in DB_AulasList)
            {
                if (aula.Activitats.Count > 0)
                {
                    aula.HaveActivitats = "Visible";
                }
            }
            listBoxobj.ItemsSource = DB_AulasList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }
        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void btnAddAula_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Aula/AddAula.xaml", UriKind.Relative));
        }

        private void listBoxobj_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (listBoxobj.SelectedIndex != -1)
            {
                Model.Aula listitem = listBoxobj.SelectedItem as Model.Aula;
                NavigationService.Navigate(new Uri("/Views/Aula/DetailAula.xaml?SelectedAulaID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void btnCalendar_Click(object sender, RoutedEventArgs e)
        {
            Model.Aula listitem = (sender as Button).DataContext as Model.Aula;
            NavigationService.Navigate(new Uri("/Views/Calendari/ReadCalendari.xaml?activitats=1", UriKind.Relative).ToString(), listitem.Activitats);
        }

        private void FilterString_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.listBoxobj.ItemsSource = DB_AulasList.Where(w => w.Nom.ToUpper().Contains(SearchTextBox.Text.ToUpper()) );


        }
    }
}