﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;

namespace DansApp.Views.Aula
{
    public partial class UpdateDeleteAula : PhoneApplicationPage
    {
        int Selected_AulaId = 0;

        DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
        Model.Aula currentAula = new Model.Aula();

        public UpdateDeleteAula()
        {
            InitializeComponent();
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            Selected_AulaId = int.Parse(NavigationContext.QueryString["SelectedAulaID"]);
            currentAula = Db_Helper.ReadAula(Selected_AulaId);
            txtNom.Text = currentAula.Nom;
            txtDireccio.Text = currentAula.Direccio;
            txtPoblacio.Text = currentAula.Poblacio;
        }

        private void btnUpdateAula_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrEmpty(txtNom.Text))
            {
                if(currentAula.Nom != txtNom.Text)
                {
                    if (!Db_Helper.ExistsAulaNom(new Model.Aula(txtNom.Text)))
                    {
                        currentAula.Nom = txtNom.Text;
                        currentAula.Direccio = txtDireccio.Text;
                        currentAula.Poblacio = txtPoblacio.Text;

                        Db_Helper.UpdateAula(currentAula);
                        NavigationService.Navigate(new Uri("/Views/Aula/ReadAulaList.xaml", UriKind.Relative));
                    }
                    else
                    {
                        MessageBox.Show("El nom ja està en ús!");//Text repeated
                    }
                }
                else
                {
                    currentAula.Nom = txtNom.Text;
                    currentAula.Direccio = txtDireccio.Text;
                    currentAula.Poblacio = txtPoblacio.Text;

                    Db_Helper.UpdateAula(currentAula);
                    NavigationService.Navigate(new Uri("/Views/Aula/ReadAulaList.xaml", UriKind.Relative));
                }
            }
            else
            {
                MessageBox.Show("El nom és obligatori!");
            }
        }

        private void btnDeleteAula_Click(object sender, RoutedEventArgs e)
        {
            MessageBoxResult msg = MessageBox.Show("Estàs segur? Això eliminarà el registre", "Atenció!", MessageBoxButton.OKCancel);
            if (msg == MessageBoxResult.Cancel)
            {

            }
            else
            {
                //MessageBox.Show("Registre esborrat", "Done", MessageBoxButton.OK);
                Db_Helper.DeleteAula(Selected_AulaId);//Delete selected DB contact Id.
                NavigationService.Navigate(new Uri("/Views/Aula/ReadAulaList.xaml", UriKind.Relative));
            }
            
        }
    }
}