﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DansApp.ViewModel;
using System.Collections.ObjectModel;
using DansApp.Model;


namespace DansApp.Views.Calendari
{
    public partial class ReadCalendari : PhoneApplicationPage
    {
        List<Model.Activitat> activitats = new List<Model.Activitat>();
        List<Model.Activitat> actDilluns = new List<Model.Activitat>();
        List<Model.Activitat> actDimarts = new List<Model.Activitat>();
        List<Model.Activitat> actDimecres = new List<Model.Activitat>();
        List<Model.Activitat> actDijous = new List<Model.Activitat>();
        List<Model.Activitat> actDivendres = new List<Model.Activitat>();
        List<Model.Activitat> actDissabte = new List<Model.Activitat>();
        List<Model.Activitat> actDiumenge = new List<Model.Activitat>();

        public ReadCalendari()
        {
            InitializeComponent();
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (activitats.Count == 0)
            {
                if (NavigationContext.QueryString.ContainsKey("activitats"))
                {
                    string parameter = NavigationContext.QueryString["activitats"];

                    switch (parameter)
                    {
                        case "1":
                            var myParameter = NavigationService.GetLastNavigationData();
                            if (myParameter != null)
                            {
                                activitats = (List<Model.Activitat>)myParameter;
                            }
                            break;
                        default:
                            break;
                    }
                }
                else
                {
                    ReadAllActivitatsList dbactivitats = new ReadAllActivitatsList();
                    var list = new List<Model.Activitat>(dbactivitats.GetAllActivitats());
                    activitats = list;
                }

                foreach (var activitat in activitats)
                {
                    string[] dies = activitat.Dia.Split(';');
                    foreach (var dia in dies)
                    {
                        if (!string.IsNullOrEmpty(dia))
                        {
                            switch (dia)
                            {
                                case "Dilluns":
                                    actDilluns.Add(activitat);
                                    break;
                                case "Dimarts":
                                    actDimarts.Add(activitat);
                                    break;
                                case "Dimecres":
                                    actDimecres.Add(activitat);
                                    break;
                                case "Dijous":
                                    actDijous.Add(activitat);
                                    break;
                                case "Divendres":
                                    actDivendres.Add(activitat);
                                    break;
                                case "Dissabte":
                                    actDissabte.Add(activitat);
                                    break;
                                case "Diumenge":
                                    actDiumenge.Add(activitat);
                                    break;
                                default:
                                    break;
                            }
                        }
                    }
                }

                lbDilluns.ItemsSource = actDilluns.OrderBy(x => x.Hora);
                lbDimarts.ItemsSource = actDimarts.OrderBy(x => x.Hora);
                lbDimecres.ItemsSource = actDimecres.OrderBy(x => x.Hora);
                lbDijous.ItemsSource = actDijous.OrderBy(x => x.Hora);
                lbDivendres.ItemsSource = actDivendres.OrderBy(x => x.Hora);
                lbDissabte.ItemsSource = actDissabte.OrderBy(x => x.Hora);
                lbDiumenge.ItemsSource = actDiumenge.OrderBy(x => x.Hora);
            }
        }

        private void lbDimarts_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDimarts.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDimarts.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDilluns_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDilluns.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDilluns.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDimecres_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDimecres.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDimecres.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDijous_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDijous.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDijous.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDivendres_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDivendres.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDivendres.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDissabte_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDissabte.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDissabte.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void lbDiumenge_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (lbDiumenge.SelectedIndex != -1)
            {
                Model.Activitat listitem = lbDiumenge.SelectedItem as Model.Activitat;
                NavigationService.Navigate(new Uri("/Views/Activitat/DetailActivitat.xaml?SelectedActivitatID=" + listitem.Id, UriKind.Relative));
            }
        }
    }
}