﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;

namespace DansApp.Views.Estadistiques
{
    public partial class ReadEstadistiques : PhoneApplicationPage
    {
        DatabaseHelperClass Db_Helper = new DatabaseHelperClass();
        ObservableCollection<DansApp.Model.Activitat> DB_ActivitatsList = new ObservableCollection<DansApp.Model.Activitat>();
        DansApp.Model.Nivell DB_Nivell = new DansApp.Model.Nivell();

        public ReadEstadistiques()
        {
            InitializeComponent();
            this.Loaded += ReadEstadistiquesList_Loaded;
        }

        private void ReadEstadistiquesList_Loaded(object sender, RoutedEventArgs e)
        {
            DB_ActivitatsList = Db_Helper.ReadTop5Activitats();
            if(DB_ActivitatsList.Count > 0)
            {
                lbActivitats.ItemsSource = DB_ActivitatsList.ToList();
            }
            else
            {
                
            }
            

            DB_Nivell = Db_Helper.ReadTopNivell();
            if(DB_Nivell != null)
            {
                txtNivell.Text = DB_Nivell.Nom;
            }
            else
            {
                txtNivell.Text = "No hi ha cap activitat";
            }
            

        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }
    }
}