﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Professor
{
    public partial class ReadProfessorList : PhoneApplicationPage
    {

        ObservableCollection<DansApp.Model.Professor> DB_ProfessorsList = new ObservableCollection<DansApp.Model.Professor>();
        ReadAllProfessorsList dbprofessors = new ReadAllProfessorsList();

        public ReadProfessorList()
        {
            InitializeComponent();
            this.Loaded += ReadProfessorList_Loaded;
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void ReadProfessorList_Loaded(object sender, RoutedEventArgs e)
        {
            
            DB_ProfessorsList = dbprofessors.GetAllProfessors();//Get all DB contacts
            foreach (var professor in DB_ProfessorsList)
            {
                if (professor.Activitats.Count > 0)
                {
                    professor.HaveActivitats = "Visible";
                }
            }
            listBoxobj.ItemsSource = DB_ProfessorsList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }


        private void btnAddProfessor_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/Views/Professor/AddProfessor.xaml", UriKind.Relative));
        }

        private void listBoxobj_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            if (listBoxobj.SelectedIndex != -1)
            {
                Model.Professor listitem = listBoxobj.SelectedItem as Model.Professor;
                NavigationService.Navigate(new Uri("/Views/Professor/DetailProfessor.xaml?SelectedProfessorID=" + listitem.Id, UriKind.Relative));
            }
        }

        private void btnCalendar_Click(object sender, RoutedEventArgs e)
        {
            Model.Professor listitem = (sender as Button).DataContext as Model.Professor;
            NavigationService.Navigate(new Uri("/Views/Calendari/ReadCalendari.xaml?activitats=1", UriKind.Relative).ToString(), listitem.Activitats);
        }

        private void FilterString_TextChanged(object sender, TextChangedEventArgs e)
        {
            this.listBoxobj.ItemsSource = DB_ProfessorsList.Where(w => w.Nom.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || w.Cognoms.ToUpper().Contains(SearchTextBox.Text.ToUpper()) || (w.Nom.ToUpper() + " " + w.Cognoms.ToUpper()).Contains(SearchTextBox.Text.ToUpper()));

        }
    }
}