﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Collections.ObjectModel;
using DansApp.ViewModel;
using DansApp.Model;

namespace DansApp.Views.Activitat
{
    public partial class SelectActivitatProfessor : PhoneApplicationPage
    {
        ObservableCollection<DansApp.Model.Activitat> DB_ActivitatsList = new ObservableCollection<DansApp.Model.Activitat>();
        Model.Professor prof = new Model.Professor();

        public SelectActivitatProfessor()
        {
            InitializeComponent();

            this.Loaded += ReadActivitatList_Loaded;
        }

        private void btnMenu_Click(object sender, RoutedEventArgs e)
        {
            NavigationService.Navigate(new Uri("/MainPage.xaml", UriKind.Relative));
        }

        private void ReadActivitatList_Loaded(object sender, RoutedEventArgs e)
        {
            ReadAllActivitatsList dbactivitats = new ReadAllActivitatsList();
            DB_ActivitatsList = dbactivitats.GetAllActivitats();//Get all DB contacts

            if (NavigationContext.QueryString.ContainsKey("professor"))
            {
                string parameter = NavigationContext.QueryString["professor"];

                switch (parameter)
                {
                    case "1":
                        var myParameter = NavigationService.GetLastNavigationData();
                        if (myParameter != null)
                        {
                            prof = (Model.Professor)myParameter;
                            
                            foreach (var activitat in prof.Activitats)
                            {
                                Model.Activitat act = DB_ActivitatsList.FirstOrDefault(x => x.Id == activitat.Id);
                                if (act != null)
                                {
                                    act.CheckboxState = true;
                                }
                            }
                            
                        }
                        break;
                    default:
                        break;
                }
            }

                lbActivitats.ItemsSource = DB_ActivitatsList.OrderBy(i => i.Nom).ToList();//Latest contact ID can Display first
        }

        private void btnSeleccionar_Click(object sender, RoutedEventArgs e)
        {
            if (prof.Id != 0)
            {
                NavigationService.Navigate(new Uri("/Views/Professor/UpdateDeleteProfessor.xaml?professor=1", UriKind.Relative).ToString(), prof);
            }
            else
            {
                NavigationService.Navigate(new Uri("/Views/Professor/AddProfessor.xaml?professor=1", UriKind.Relative).ToString(), prof);
            }
        }
        
        private void lbActivitats_Tap(object sender, System.Windows.Input.GestureEventArgs e)
        {
            Model.Activitat listitem = lbActivitats.SelectedItem as Model.Activitat;
            
            if (listitem != null)
            {
                if (!listitem.CheckboxState)
                {
                    listitem.CheckboxState = true;
                    Model.Activitat act = prof.Activitats.FirstOrDefault(x => x.Id == listitem.Id);

                    if (act == null)
                    {
                        prof.Activitats.Add(listitem);
                    }
                }
                else
                {
                    listitem.CheckboxState = false;
                    Model.Activitat act = prof.Activitats.FirstOrDefault(x => x.Id == listitem.Id);

                    if(act != null)
                    {
                        prof.Activitats.Remove(act);
                    }
                }
            }
        }
        
    }
}